screenErase=1
switch_screenErase(){
	[[ "$1" != ?([01]) ]] && p_err "wrong argument: '$1'" && return 2
	(( debug & screenErase )) && debugMsg "debug on. screenErase turned off."
	(( debug )) && screenErase=0 && return 0
	(( opt_switch_screenerase )) && return 0
	screenErase=$1
	debugMsg "screenErase: '$screenErase'"
	return 0
}
interactive_mode(){
	(( screenErase )) && printf "\033[2J\r" # Clear entire screen 
	print_menu=1
	while (( opt_interactive )); do
		choose_menu_option
	done
	(( screenErase )) && printf "\033c" # erase screen (Reset terminal to initial state)
	return 0
}

choose_menu_option(){
	(( screenErase )) && printf "\033c" # erase screen (Reset terminal to initial state)
	        # see: 'VT100 escape codes.html' (saved locally)
	        # and: https://stackoverflow.com/questions/5367068/clear-a-terminal-screen-for-real
	if (( print_menu )); then
		echo "[interactive mode]"
	
		printf "  ----- Menu -----\n"
		echo
		printf "    <keyID>\n"
		printf "        Decode IPHR with given keyID\n"
		echo
		printf "    m <method_id>\n"
		printf "        Use decoding method with specified id.\n"
		printf "           1  date/charnum    (default)\n"
		printf "           2  XOR_charlist64\n"
		echo
		printf "    l   List key IDs and assignments.\n"
		echo
		printf "    e   Encode IPHR\n"
		echo
		printf "    d   Give IPHR to decode directly, not from database.\n"
		printf "        Enter a <18-byte-hex-string> or <0o+octal-number>\n"
		echo
		printf "    se, -switch-screenerase\n"
		printf "        Switch on/off screen eraseing.\n"
		echo
		printf "    cdb, -choose-database\n"
		printf "        Pick another database file.\n"
		echo
		printf "    h, -help\n"
		printf "        Print help message and other options.\n"
		echo
		printf "    q   Quit\n"
		echo
		printf "  ----------------\n"
	fi
	local answer
	read answer
	while [[ "$answer" == "" ]];do
		printf "\033[A\r\033[0K"
		printf "Answer was empty. ('q' to quit)"
		sleep 1.5
		printf "\r\033[0K"
		read answer
	done
	printf "\033[0K\r"

	[[ "$answer" == +([qQ]) ]] && opt_interactive=0 && echo "Exit." && return 0
	# prepare for parseOptions() by prepending an "options dash" '-'
	[[ "$answer" != ?(-)+([0-9]) ]] && answer="-$answer"
	debugMsg "answer '$answer'"

	opt_encode=0
	opt_decode=0
	opt_list=0
	keyID=-1
	unencoded_IPHR_input=""
	fail=0
	directDecode=0 # if IPHR is given as an argument
	keep_submenu=0
	if ! parseOptions $answer; then
		(( !debug )) && sleep 3
		switch_screenErase 1
		return 1
	fi
	(( debug )) && switch_screenErase 0 || switch_screenErase 1
	(( opt_decode | opt_encode )) && keep_submenu=1
	while (( keep_submenu )); do
		debugMsg "in opt_encode/opt_decode submenu"
		(( screenErase )) && printf "\033c" # erase screen (Reset terminal to initial state)
		! main && switch_screenErase 0 && sleep 1 || switch_screenErase 1
		echo
		if (( opt_decode & !directDecode )); then
			echo "Type next keyID."
		else
			echo "Hit any key to continue"
		fi
		echo "(hit 'm' to get back to menu, 'q' to quit.)"
		(( opt_encode | directDecode )) && read -s -n 1 answer || read answer
		[[ "$answer" == +([mM]) ]] && return 0
		[[ "$answer" == +([qQ]) ]] && opt_interactive=0 && return 0
		if (( opt_decode )); then
			(( directDecode )) && directDecode=0 && return 0
			while ! checkValid_keyID $answer; do
				read answer
				[[ "$answer" == +([mM]) ]] && return 0
				[[ "$answer" == +([qQ]) ]] && opt_interactive=0 && return 0
			done
		fi
	done
	(( screenErase )) && printf "\033c" # erase screen (Reset terminal to initial state)
	! main && switch_screenErase 0 && sleep 1 || switch_screenErase 1

	return 0
}
