/*
 *     License and DISCLAIMER :)
 *
 *     with this i am 
 *		trying stuff / having fun / relax when i am tinkering 
 *     while learning 
 *		c / bash / zsh / unix tools / ... / programming.
 *     so its very likely, that this is buggy, 
 *     poor style, and other things c-code (or other code) might be, or even unfinished 
 *     or not working...
 *   
 *     But take it, and do whatever you want to do with this, learning like i do,
 *     or what you like. Tell me what you do or think about this, if you like at 
 *   		hallo@timte.org
 *   
 *     so until i know better, i use GPL 3.0 in case i publish this simple thing...
 *   
 *     Copyright (C) 2023 timte Ⓐ 
 *     updates (and other stuff) may be at https://timte.org/source/
 *    
 *     This program is free software: you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation, either version 3 of the License.
 *    
 *     This program is distributed in the hope that it will be useful, (or just fun),
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *     See <https://www.gnu.org/licenses/>.
 *
 *
 *     To include the code to the binary compile with a crc16_nk.c.h header file
 *     that has all changes of the main.c by:
 *         xxd -i crc16_nk.c > crc16_nk.c.h ; gcc -o crc16_nk crc16_nk.c
 *     To ensure this, remove the header file after compilation, to refuse
 *     compiling without reproduction:
 *         rm -f crc16_nk.c.h
 *
 */


#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include <fcntl.h>
#include <sys/stat.h>
#include <unistd.h>

#define POLY1021 0x1021
#define POLY8005 0x8005

// produce own source code of this file by
//   xxd -i "filename" > "filename".h
#include "crc16_nk.c.h"

// A function to display an error message and then exit
void fatal(char *message) {
	char error_message[100];
	strcpy(error_message, "[Error] "); 
	strncat(error_message, message, 83); 
	perror(error_message);
	exit(-1);
}

// from booksrc 'Hacking 2nd ed'
void *ec_malloc(unsigned int size) { // an error checked malloc() function
	void *ptr;
	ptr = malloc(size);
	if(ptr == NULL) {
		fprintf(stderr, "Error: could not allocate heap memory.\n");
		exit(-1);
	}      
	return ptr;
}

void printbin(uint16_t input){
	int i=0, mask;
	for(i=0; i<16; i++){
		mask=0x8000;
		if(input & mask>>i){
			printf("1");
		} else {
			printf("0");
		}
		if ((i+1)%4==0) printf(" ");
	}
	printf("\n");
}

/*   stuct bin_data *decode_base64(char *base64)
 *      Decodes base 64 encoded data.
 *      Call with a pointer to a base 64 encoded string.
 *      Returns a bin_data struct pointer with the decoded base 64
 *      data char pointer and its size as an integer.
 *      Returns NULL and prints an error message, if the argument 
 *      given was not base 64.
 *   
 *   char *encodebase64(char *string, int size)
 *      Encodes data to base 64.
 *      Call with a pinter to the data and its length 'size'.
 *      Returns a char pointer to a base 64 string.
 */

char base64charset[64]=
	{"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"};
	//0123456789abcdef0123456789abcdef0123456789abcdef0123456789abcdef
	//0 | | | | | | | 1 | | | | | | | 2 | | | | | | | 3 | | | | | | | 
	//0123456789012345678901234567890123456789012345678901234567890123
	//0         1         2         3         4         5         6

// decode base64 string (that could contain newline-chars) 
// to a binary string (that of course could contain zeros, like
// every other value, so is no "string" in the sense of printable
// and is not NULL terminated but its length is defined by a 
// size 'int size'
 /*
	  to do:
	  - check if whitespace elimination works
	  - clean up
	  - rename variables. e.g. b64leng is used in the loop:
			 // shorten the size of bin_string by appendleng
		 this is length of bin_string not raw_base64 or another...
	  - check previously made comments (was the pseudocode at the beginning)
		 if something is missing
  */

/* structs element access (from Hacking-taoe S.97):
		struct tm current_time, *time_ptr;
		int hour, minute, second, day, month, year;
	[...]
		// Three different ways to access struct elements: 
		hour = current_time.tm_hour;   // Direct access
		minute = time_ptr->tm_min;     // Access via pointer 
		second = *((int *) time_ptr);  // Hacky pointer access
*/
struct bin_data{
	int size;
	char *data;
};

/* call func for example like this:
		struct bin_data *decodedb64 = decode_base64(inputstring);
		if(decodedb64 == NULL)
			return 0;
	
free after use:
		free(decodedb64->data);
		free(decodedb64);
*/
struct bin_data *decode_base64(char *base64){
	int i, j, k;
	int b64leng = strlen(base64);
	struct bin_data *decoded_data = ec_malloc(sizeof(struct bin_data));
	unsigned char value_6bit[4] = {0};
	// for caching the values of base64-chars and operate on single b64chars

	// search newline, space, and tab chars in 'base64' and remove them; save in raw_base64;
	char *raw_base64 = ec_malloc(b64leng);
	for(i=0, j=0; i<b64leng; i++){
		if(base64[i] != 0x0a && base64[i] != 0x20 && base64[i] != 0x09)
			raw_base64[i-j] = base64[i];
		else j++;
	}
	raw_base64[i-j] = 0;
	b64leng -= j;

	int appendleng = 0;
	for(i=b64leng; i>b64leng-2; i--)
		if(raw_base64[i-1] == '=')
			appendleng++ ;
	
	// Append base64-zeros
	for(i=1; i<=appendleng; i++)
		raw_base64[b64leng-i] = 'A';
	decoded_data->size = strlen(raw_base64) / 4 * 3 - appendleng;
	decoded_data->data = ec_malloc(decoded_data->size);
	
	// decode base64:
	// another method (probably more expensive(?)):
	//  iterate through base64charset for every 'b64char' of 'base64', 
	//  break loop if 'b64char' matched, and get i. this is the 6 bit 
	//  number for 'b64char'.
	unsigned int conversion_int = 0;
	for(i=0, k=0; i<b64leng; i+=4, k+=3){	// k = 4 to keep the first 4 bytes free to save the size
		for(j=0; j<4 && j+i < b64leng; j++){
			if     (raw_base64[i+j] > 0x40 && raw_base64[i+j] < 0x5b) // if raw_base64[i+j] is a capital letter
				value_6bit[j] = raw_base64[i+j] - 0x41;	   //   -0x41=-41+00 ; 0x00 is the value for base64 'A'
			else if(raw_base64[i+j] > 0x60 && raw_base64[i+j] < 0x7b) // if its a small letter (0x61 to 0x7a)
				value_6bit[j] = raw_base64[i+j] - 0x47;	   //   -0x47=-61+1a ; 0x1a is the value for base64 'a'
			else if(raw_base64[i+j] > 0x2f && raw_base64[i+j] < 0x3a) // if its a number (0x30 to 0x39)
				value_6bit[j] = raw_base64[i+j] + 0x04; 	   //   0x04=-30+34 ;  0x34 is the value for base64 '0'
			else if(raw_base64[i+j] == 0x2b)
				value_6bit[j] = 0x3e; 			   // 0x3e is the value for base64 '+'
			else if(raw_base64[i+j] == 0x2f)
				value_6bit[j] = 0x3f;			   // 0x3f is the value for base64 '/'
			else{
				printf("the string was not base64.\n");
				printf("the character '%c' (0x%02x) was part of the string\n", raw_base64[i+j], raw_base64[i+j]);
				return NULL;
			}
			conversion_int <<= 6;
			conversion_int |= value_6bit[j];
		}
		for(j=2; j>=0 && j+i < b64leng; j--){
			decoded_data->data[k+j] = conversion_int;
			conversion_int >>= 8;
		}
	}

	free(raw_base64);
	return decoded_data;
}

//encode string to a base64 string
char *encodebase64(char *string, int size){
	int i, j;
	int appendleng = 0;
	if(size % 3 > 0)
		appendleng += 3 - size % 3;
	
	int leng = (size + appendleng) / 3 * 4;
	char *base64 = (char *) ec_malloc(leng+1);
	base64[leng]= '\0';

	int converted_int = 0;
	for(i=0; i<size; i+=3){
		for(j=0; j<3; j++){
			converted_int<<=8;
			converted_int|=(unsigned char)string[i+j];
		}
		for(j=3; j>=0; j--){
			base64[i/3*4+j] = base64charset[converted_int & 0x3f];
			converted_int >>= 6;
		}
		converted_int=0;
	}
	for(i=1; i<=appendleng; i++){
		base64[leng-i]= '=';
	}
	return base64;
}

int main(int argc, char *argv[]){
	if(argc==2 && strcmp(argv[1], "--source")==0){
		crc16_nk_c[crc16_nk_c_len]=0;
		printf("%s", crc16_nk_c);
		return 0;
	}

	if(argc<2){
		printf("Usage:  %s  <string> | -f <file> | -b64 <base64-string>  [-verbose]\n", argv[0]);
		printf("        Print source / license with:  %s --source\n", argv[0]);
		return 0;
	}
	if(argc > 2 ){
		if(strncmp(argv[1], "-", 1) != 0){
			fatal("not an argument.");
		}
	}
	int verbose=0;
	if( ( argc>2 && strcmp(argv[2], "-verbose")==0 ) || ( argc>3 && strcmp(argv[3], "-verbose")==0 ) ){
		verbose=1;
	}

	if(verbose){
		printf("poly: 0x%04x   bin: ", POLY1021);
		printbin(POLY1021);
		printf("\n");
	}

	unsigned long int i, input_size;
	char *input_data;
	int opt_b64=0;
	struct bin_data *decodedb64;

	if(argc >= 2 ){
		if(strncmp(argv[1], "-f", 2) == 0){
			if(argc < 3){ printf("No file name given.\n"); return 0; }
			char *filename = argv[2];
			int fd = open(filename, O_RDONLY);
			if(fd == -1)
				fatal("in main() while opening file");

			struct stat st;
			stat(filename, &st);
			input_size = st.st_size;
		
			input_data = ec_malloc(input_size);
			read(fd, input_data, input_size);
			if(close(fd) == -1)
				fatal("in main() while closing file");

			input_data[input_size] = 0;
		/* // use stdin as input
		} else if ( strncmp(argv[1], "-i", 2)==0 ) {
			printf("input is stdin\n");
			input_size=3;
			input_data = ec_malloc(input_size);
			char ch;
			while(read(STDIN_FILENO, &ch, 1) > 0){
				
			}

			//scanf("%s", input_data);
		*/
		} else if ( strncmp(argv[1], "-b64", 2)==0 ) {
			opt_b64=1;
			if(argc < 3){ printf("No base64 input given.\n"); return 0; }
			input_data = argv[2];
			struct bin_data *decodedb64 = decode_base64(input_data);
			if(decodedb64 == NULL)
				return 0;
			input_data=decodedb64->data;
			input_size=decodedb64->size;
		} else {
			input_data = argv[1];
			input_size = strlen(argv[1]);
		}
	}
	if (input_size==0){
		printf("Input empty.\n");
		return 0;
	}

	uint16_t crc=0xffff;
	if(verbose){
		printf("crc init:     ");
		printbin( crc );
	}

	for(i=0; i<input_size; i++){
		crc ^= ( (uint16_t)input_data[i] << 8 );
		if(verbose){
			printf("XOR input[%02zu] ", i);
			printbin( (uint16_t)input_data[i] << 8 );
			printf("crcXOR        ");
			printbin( crc );
		}
		for(int bit=8; bit>0; bit--){
			if( crc & 0x8000){
				crc = (crc << 1) ^ POLY1021;
				if(verbose){
					printf("sftXOR[%02zu][%d] ", i, bit);
					printbin( crc );
				}
			} else {
				crc <<= 1;
				if(verbose){
					printf("shift [%02zu][%d] ", i, bit);
					printbin( crc );
				}
			}
		}
	}
	if(verbose){
		printf("\ncrc ");
		printbin(crc);
	}

	printf("0x%04x\n", crc);

	/* free leads to seg fault 11. Don't know why...
	*  Because input_data was shifted is the only idea, but I don't understand.
	if(opt_b64){
		free(decodedb64->data);
		free(decodedb64);
	 } */
	
	return 0;
}
